package db

import (
	"bytes"
	"compress/gzip"
	"io/ioutil"
)

func Gzip(data []byte) ([]byte, error) {
	var b bytes.Buffer
	gz := gzip.NewWriter(&b)
	if _, err := gz.Write(data); err != nil {
		return data, err
	}
	if err := gz.Close(); err != nil {
		return data, err
	}
	return b.Bytes(), nil
}

func Gunzip(data []byte) ([]byte, error) {
	var (
		gz  *gzip.Reader
		out []byte
	)
	r := bytes.NewReader(data)
	if gz, err = gzip.NewReader(r); err != nil {
		return nil, err
	}
	if out, err = ioutil.ReadAll(gz); err != nil {
		return nil, err
	}
	return out, nil
}
